#!/usr/bin/perl

########################################
#                                      #
# C O N F I G U R A T I O N            #
#                                      #
########################################

$dbusername = "username";
$dbpassword = "password";

########################################
#                                      #
# I N C L U D E S                      #
#                                      #
########################################

use DBI;
require "common.pl";

########################################
#                                      #
# M A I N                              #
#                                      #
########################################

# FLOW:
#	1. Decode the form data
#	2. What is happening?
#		a. New Reg ( sub newreg() )
#		b. Confirm Reg ( sub confirmreg() )
%cookies = ();
$cookiecount = 0;
dbconnect();
checkcookie();
decode();

if ( $action =~ /^1$/ ) { newreg(); }		# display new registration page
elsif ( $action =~ /^2$/ ) { confirmreg(); }	# link from e-mail goes here: acc activation
elsif ( $action =~ /^3$/ ) { postreg(); }	# instructionpage to wait for e-mail
elsif ( $action =~ /^4$/ ) { finished(); }	# confirm final phase complete
else { newreg(); }				# display default index page anyway...

exit;

########################################
#                                      #
# S U B S                              #
#                                      #
########################################

sub htmlheader {

	# note: we don't need to set any cookies here...
		
	print "Content-type: text/html\n\n";
	print "
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">
<html>
<head>
  <title>Sample CGI App</title>
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
  <meta name=\"GENERATOR\" content=\"Perl CGI\">
</head>
<body>
	";

}

sub htmlfooter {

	print "</body></html>";

}

sub newreg {

	htmlheader();
	print "
<h3>New User Registration</h3>
<p>
  <form action=\"/cgi-bin/userreg.pl\">
    <input type=\"hidden\" name=\"action\" value=3>
    <table width=500 align=\"center\">
      <tr>
        <td width=150 bgcolor=\"#e4e4e4\"><div align=\"center\"><b>Username</b></div></td>
        <td><div align=\"left\"><input type=\"text\" name=\"username\"> <font size=-1><b>max. 15 characters</b></font></div></td>
      </tr>
      <tr>
        <td width=150 bgcolor=\"#e4e4e4\"><div align=\"center\"><b>E-Mail</b></div></td>
        <td><div align=\"left\"><input type=\"text\" name=\"email\"> <font size=-1></font></div></td>
      </tr>
      <tr>
        <td colspan=2><div align=\"center\"><input type=\"submit\"><input type=\"reset\"></div></td>
      </tr>
    </table>
  </form>
</p>
	";
	htmlfooter();
	exit;

}

sub confirmreg {

	# here we get te following info:
	# $checksum = 32 character string

	# does this checksum exist?
	$sql1 ="SELECT uid FROM users WHERE checksum = '$checksum' LIMIT 0,1";
	$sth1 = $dbh1->prepare( $sql1 );
	$rv1 = $sth1->execute();
	if ( $rv1 =~ /^0E0/ ) {
	
		printerr( "General SQL Error [1]\n" );
		exit;
	
	} else {
	
		while ( ( $uid1 ) = $sth1->fetchrow_array() ) {
		
			$uid = $uid1;
		
		}
	
	}

	htmlheader();
	print "
<h1>Account Activation for $uid</h1>
<hr>
<p>
  <form action=\"/cgi-bin/userreg.pl\" method=\"POST\">
    <input type=\"hidden\" name=\"action\" value=4>
    <input type=\"hidden\" name=\"checksum\" value=\"$checksum\">
    <table width=400 align=\"center\">
      <tr>
        <td colspan=2>The final part of the account activation is to confirm your new password. Please select one noe, and enter it here.</td>
      </tr>
      <tr>
        <td width=150 bgcolor=\"#e4e4e4\"><div align=\"center\"><b>Password</b></div></td>
        <td><div align=\"center\"><input type=\"password\" name=\"password1\"></div></td>
      </tr>
      <tr>
        <td width=150 bgcolor=\"#e4e4e4\"><div align=\"center\"><b>Confirm Password</b></div></td>
        <td><div align=\"center\"><input type=\"password\" name=\"password2\"></div></td>
      </tr>
      <tr>
        <td colspan=2><div align=\"center\"><input type=\"submit\"><input type=\"reset\"></div></td>
      </tr>
    </table>
  </form>
</p>	
	";
	htmlfooter();
	exit;

}

sub postreg {

	# is this username available? If yes, do the initial registration
	$now = time;
	$sql1 = "SELECT COUNT( uid ) FROM users WHERE uid = '$username'";
	$sth1 = $dbh1->prepare( $sql1 );
	$rv1 = $sth1->execute();
	if ( $rv1 =~ /^0E0/ ) {
	
		# critical error...
		printerr( "Error getting data from the DB [3]\n" );
		exit;
	
	} else {
	
		while ( ( $counter ) = $sth1->fetchrow_array() ) {
		
			if ( $counter < 1 ) {
			
				$sql2 = "INSERT INTO users ( uid,uidencoded, email, status, checksum, regdate, sessionid, sessionactivity ) VALUES ( '$username', MD5( '$username' ), '$email', '0', MD5( '$now' ), NOW(), '', NOW() )";
				$dbh2->do( $sql2 );
			
			} else {
			
				# username exists
				printerr( "User Name Exists [1]\n" );
				exit;
			
			}
		
		}
	
	}
	
	# Get the checksum value
	$sql3 = "SELECT checksum FROM users WHERE uid = '$username'";
	$sth3 = $dbh1->prepare( $sql3 );
	$rv3 = $sth3->execute();
	if ( $rv3 =~ /^0E0/ ) {
	
		# problem - report to sysadmin
		printerr( "There was a database error while creating your account. Please click on the following link to send an e-mail to our administrator: <a href=\"mailto:root\@localhost?subject=regerr-$username\"root AT localhost</a>.\n" );
		exit;
	
	} else {

		while ( ( $checksum1 ) = $sth3->fetchrow_array() ) {
		
			$checksum = $checksum1;
		
		}
	
	}
	
	# prepare the e-mail message
	$msg = "
Thank you for registering for our website. You must click on the\n
following link, or copy it and open it in a web browser:\n
http://127.0.0.1/cgi-bin/userreg.pl?action=2&checksum=$checksum
	";
	
	# your e-mail routine should now go here...
	#
	#	--- email routine ---
	#

	# now, print the wait message. 
	#
	# NOTE: In this example, we print the e-mail message in the browser for debugging info
	
	htmlheader();
	print "
<h3>Confirmation</h3><hr>
<p>
We have sent a confirmation e-mail to the address you supplied. In this e-mail there will be
further instructions on how to activate your account.
</p>
<hr>
<p>
<b>Debug Info</b>
</p><p>
$msg
</p>
	";
	htmlfooter();
	exit;

}

sub finished {

	# we should get in here:
	# $checksum => the 32 character checksum
	# $password1 => password nr 1
	# $password2 => password nr 2.
	#
	# the acc is activated if password1 = password2
	if ( $password1 =~ /^$password2$/ ) {
	
		# MATCHED - activate account
		$sql = "UPDATE users SET status = '1', checksum = NULL, password = MD5( '$password1' ) WHERE checksum = '$checksum'";
		$dbh1->do( $sql );
	
	} else {
	
		printerr( "Passwords don't match - please correct and try again. [1]\n" );
		exit;
	
	}

	htmlheader();
	print "<p>Account Activated. Please go to the <a href=\"/cgi-bin/login.pl\">login page</a> to log in for the first time.";
	htmlfooter();
	exit;

}
